clear all;
clc;

% Load simulation data from file
data = xlsread('data.xls');

sod= data(:,3);
time = data(:,1);

% Initialization
x = 0;
s(1)=0;
P = 0;  % Initial variance of the states  

% Define Phi, H, Q, and R 
Phi = 1;
Q =  0.5;             % Process noise covariance
R =  1;             % Measurement noise covariance

% Define measurement
Z0 = data(:,2);


for i=1:(length(Z0)-1)
    Z(i)=Z0(i+1)-Z0(i);
    
    H = (-5.50031982115)+2*(3.52835024106)*s(i)+3*(336.557689459)*s(i)^2+4*(-3446.09558946)*s(i)^3+5*16040.7981555*s(i)^4+6*(-42019.7227482)*s(i)^5+7*65654.8373428*s(i)^6+8*(-60717.9516271)*s(i)^7+9*30679.8806384*s(i)^8+10*(-6528.27276151)*s(i)^9;
    % 1. Compute Kalman Gain:
    K=P*H/(H*P*H+R);
    
    % 2. Update estimate
    x=x+K*(Z(i)-H*x);
    
    % Save estimated data
    x_new(i)=x;
    s(i+1)=s(i)+x_new(i);
    residual(i) = (Z(i) - H*x);
    
    % 3. Update Covariance Matrix
    P=(1-K*H)*P*(1-K*H)+K*R*K;
    
    % 4. Propagate the track estimate::
    x=Phi*x;
    
    % 5. Propagate the covariance matrix:
    P=Phi*P*Phi+Q;
end

% Plot results
plot(time,s);